//2_SchriftenZuweisen_203d.js
// 28.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Dient zum ndern der Schriften der Absatz- und Zeichenformate

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

var curDoc = app.documents[0];

// den Inhalt des Rahmens, welcher die Namen der Absatzformate enthlt, 
// in die Variable 'paraStory' geben 
try {
	var paraStory = curDoc.textFrames.item("paraStyles").parentStory;
	var nParas = paraStory.paragraphs.length;
}
catch (e) {
	alert ("Der Rahmen mit den Formatmustern\nist unauffindbar.", "Achtung");
	exit();
}

// prfen, ob noch fehlende Schriften im Dokument vorhanden sind
try {
	dfList = curDoc.fonts;
}
catch (e) {
}
var nFonts = dfList.length;
var curStatus;
var okay = true;
for (var i=0; i<nFonts; i++) {
	curStatus = dfList[i].status;
	if (curStatus == 1718832705) {
		okay = false;
		break;
	}
}
if (!okay) {
	var userDec = confirm ("Weiterfahren?\n\nEs hat noch fehlende Schriften!");
	if (userDec == false) {
		exit();
	}
}

// eine Schleife durch die Abstze
var paraFont;
var paraStyle;
for (var i=0; i<nParas; i++) {
	try {
		paraFont = paraStory.paragraphs[i].characters[-2].appliedFont.name;
		paraStyle = paraStory.paragraphs[i].appliedParagraphStyle;
		paraStyle.appliedFont = paraFont;
	}
	catch (e) {
	}
}

// den Inhalt des Rahmens, welcher die Namen der Zeichenformate enthlt, 
// in die Variable 'charStory' geben 
try {
	var charStory = curDoc.textFrames.item("charStyles").parentStory;
	var nChars = charStory.paragraphs.length;

	// eine Schleife durch die Liste
	var charFont;
	var charStyle;
	for (var i=0; i<nChars; i++) {
		try {
			charFont = charStory.paragraphs[i].characters[-2].appliedFont.name;
			charStyle = charStory.paragraphs[i].characters[-2].appliedCharacterStyle;
			charStyle.appliedFont = charFont;
		}
		catch (e) {
		}
	}
}
catch (e) {
}

// die Rahmen entfernen
try {
	curDoc.textFrames.item("paraStyles").remove();
}
catch (e) {
}
try {
	curDoc.textFrames.item("charStyles").remove();
}
catch (e) {
}

alert ("Fertig.", " ");